/*
 * Legato is a configurable, lightweight web mapping client that can be
 * easily embedded into web pages and portals, CMS and individual web
 * applications. Legato is implemented in JavaScript and based on the
 * popular open source library OpenLayers.
 *
 * Copyright (C) 2010  disy Informationssysteme GmbH, http://www.disy.net
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Component: olc:LayerSwitcher
 *
 * Displays a table of contents for the map. This allows the user
 * interface to switch between base layers and to show or hide overlays.
 *
 * Inherits from:
 * - <olc:Control>
 *
 * See also:
 * - <olc> namespace
 * - <OpenLayers.Control.LayerSwitcher>
 * - <lc:Legend>
 */
OpenLayers.Control.LayerSwitcher.Bean = OpenLayers.Control.Bean.Extend(
  'OpenLayers.Control.LayerSwitcher',
  Legato.OpenLayers.Control.QName('LayerSwitcher'),
  {
    options : {
      /**
       * Element: ascending
       * {Boolean}
       */
      ascending : Legato.Lang.Boolean,
        /**
         * Element: activeColor
         * {String}
         */
        activeColor: "darkblue"

    },
    _constructor : OpenLayers.Control.LayerSwitcher
  }
);